//
// Copyright (c) Microsoft. All rights reserved.
// See https://aka.ms/azai/vision/license for the full license information.
//

#pragma once
#include <azac_api_cxx_details_property_collection.h>
#include <vision_api_cxx_common.h>

namespace Azure {
namespace AI {
namespace Vision {
namespace ImageAnalysis {

/// <summary>
/// Represents the collection of properties on a given Image Analysis result object
/// </summary>
class ImageAnalysisResultProperties : private AI::Core::Details::PropertyCollectionBase<>
{
private:
    template<typename Target>
    using ProtectedAccess = Azure::AI::Core::Details::ProtectedAccess<Target>;
    using PropertyCollection = AI::Core::Details::PropertyCollectionBase<>;

public:
    using PropertyCollection::Get;
    using PropertyCollection::GetBinary;

protected:
    /*! \cond PROTECTED */
    ImageAnalysisResultProperties(AZAC_HANDLE handle) : PropertyCollection(handle) {}
    explicit operator AZAC_HANDLE() { return ProtectedAccess<PropertyCollection>::HandleFromPtr(this); }
    /*! \endcond */
};

} } } } // Azure::AI::Vision::ImageAnalysis
